import java.util.*;
import java.lang.*;
import netscape.javascript.*;

public class WaitRoom
{
	Hashtable users = new Hashtable();	
	JSObject win;
	String sep;
	ChatClient client;
	
	public WaitRoom(ChatClient pClient)
	{
		client = pClient;
		
		win = client.win;
		sep = client.sep;
	}
	
	public void RecvJoin(String pUserid, String pName, String pIcon, String pMaster)
	{
		User user = new User(pUserid, pName, pIcon, pMaster);
		users.put(pUserid, user);
		
		WriteList();
	}
	
	public void RecvExit(String pUserid, String pName, String pIcon, String pMaster)
	{
		users.remove(pUserid);
		
		WriteList();
	}
	
	public void RecvList(int pCount, StringTokenizer pToken)
	{
		users.clear();
		
		for(int i = 0; i < pCount; i++)
		{
			String id = pToken.nextToken();
			String name = pToken.nextToken();
			String icon = pToken.nextToken();
			String master = pToken.nextToken();
			
			User user = new User(id, name, icon, master);
			users.put(id, user);

		}
		
		WriteList();
	}
	
	public void WriteList()
	{
		win.eval("WriteWaitUsersListStart(\"" + users.size() + "\")");
		
		Enumeration e = users.elements();
		
		while (e.hasMoreElements())
		{
			User user = (User)e.nextElement();
			win.eval("WriteWaitUsersList(\"" + user.strUserid + "\", \"" + user.strName + "\", \"" + user.strIcon + "\")");
		}
		
		win.eval("WriteWaitUsersListEnd()");
		
	}
	
	public void RecvJoinRoomInit(String pUserid, String pName, String pIcon, String pRoomid, String pRoomname, String pMaster)
	{
		client.strRoomid = pRoomid;
		client.strMaster = pMaster;
		client.send("JOIN", "");
		win.eval("JoinRoom(\"" + pRoomname + "\")");
		
	}
	
	public void RecvRoomList(int pCount, StringTokenizer pToken)
	{
		win.eval("WriteRoomListStart(\"" + users.size() + "\")");
		
		for(int i = 1; i <= pCount; i++)
		{
			String roomid		= pToken.nextToken();
			String roomname		= pToken.nextToken();
			String roomlimit	= pToken.nextToken();
			String roomtype		= pToken.nextToken();
			String roompass		= pToken.nextToken();
			String roomgroup	= pToken.nextToken();
			String roomusersize	= pToken.nextToken();
			
			win.eval("WriteRoomList(\"" + i + "\", \"" + roomid + "\", \"" + roomname + "\", \"" + roomlimit + "\", \"" + roomtype + "\", \"" + roompass + "\", \"" + roomgroup + "\", \"" + roomusersize + "\")");
				
		}
		
		win.eval("WriteRoomListEnd()");
	}
	
	public void RecvMakeRoom()
	{
		client.send("ROOMLIST", "");
	}
	
	public void RecvRemoveRoom()
	{
		client.send("ROOMLIST", "");
	}
	
	public void RecvJoinRoom()
	{
		client.send("ROOMLIST", "");
	}
	
	public void RecvMemo(String pUserid, String pName, String pIcon, String pMsg)
	{
		win.eval("WriteMemo(\"" + pUserid + "\", \"" + pName + "\", \"" + pIcon + "\", \"" +  pMsg + "\")");
	}
}