import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;
import java.lang.*;
import netscape.javascript.*;

public class Client extends Applet 
{
	AppletContext ac = null;
	public JSObject win;
	
  	ChatClient chatclient;
	String strHost = null;
	int iPort;
	public String sep;
	
	public void init()
	{
  		setLocale(Locale.KOREA);
  		sep = "|!";
  		
  		win = (JSObject)JSObject.getWindow(this);
  		
	    try 
	    { 
			ac = getAppletContext();			
	    }
	    catch(Exception exc)
	    {
	    }
	      	
		if(strHost == null)
	  	{
			strHost = getCodeBase().getHost();
			
			try
			{
				iPort= Integer.parseInt(getParameter("PORT"));
			}
			catch (Exception e)
			{			
			}
	  	}        
  		
		chatclient = new ChatClient(this);
		
		chatclient.strName		= getParameter("name");
  		chatclient.strUserid	= getParameter("userid");
  		chatclient.strIcon		= getParameter("icon"); 
  		chatclient.strRoomid	= "0";
  		chatclient.strMaster	= "";
		
		chatclient.connect(strHost, iPort);
    
	}
	
	public String GetUserid()
	{
		return chatclient.strUserid;
	}
	
	public String GetName()
	{
		return chatclient.strName;
	}
	
	public String GetIcon()
	{
		return chatclient.strIcon;
	}
	
	public String GetMaster()
	{
		return chatclient.strMaster;
	}
	
	public String GetRoomid()
	{
		return chatclient.strRoomid;
	}
	
	public void SetUserid(String pValue)
	{
		chatclient.strUserid = pValue;
	}
	
	public void SetName(String pValue)
	{
		chatclient.strName = pValue;
	}
	
	public void SetIcon(String pValue)
	{
		chatclient.strIcon = pValue;
	}
	
	public void SetRoomid(String pValue)
	{
		chatclient.strRoomid = pValue;
	}
	
	public void destroy()
	{
		chatclient.disconnect();
	}	
	
	public void ExitRoom()
	{
		chatclient.disconnect();
	}
	
	public String MakeFontString(String pStr, String pFontColor, String pFontSize, String pFontName, String pFontBold, String pFontItalic, String pFontUnderline)
	{	
		String strHeader;
		String strTail;
		
		strHeader = "<span style='font-family:" + pFontName + "; font-size:" + pFontSize + "pt; color:" + pFontColor + "'>";
		
		strTail= "</span>";
			
		if (!pFontBold.equals("0"))
		{
			strHeader = "<b>" + strHeader;
			strTail = strTail + "</b>";
		}
		
		if (!pFontItalic.equals("0"))
		{
			strHeader = "<i>" + strHeader;
			strTail = strTail + "</i>";
		}
		
		if (!pFontUnderline.equals("0"))
		{
			strHeader = "<u>" + strHeader;
			strTail = strTail + "</u>";
		}
		
		return strHeader + pStr + strTail;
	}
	
	public void SendMakeRoom(String pRoomname, String pRoomlimit, String pRoomtype, String pRoompass, String pRoomgroup)
	{
		chatclient.send("MAKEROOM", "" + sep + pRoomname + sep + pRoomlimit + sep + pRoomtype + sep + pRoompass + sep + pRoomgroup);
	}
	
	public void SendJoinRoom(String pRoomid)
	{
		chatclient.send("JOINROOM", "" + sep + pRoomid);
	}
	
	public void SendJoinSecretRoom(String pRoomid, String pPasswd)
	{
		chatclient.send("JOINSECRETROOM", "" + sep + pRoomid + sep + pPasswd);
	}
	
	public void SendMsg(String pStr, String pFontColor, String pBackColor, String pFontSize, String pFontName, String pFontBold, String pFontItalic, String pFontUnderline)
	{
		String strMessage;
		
		strMessage = pStr + sep + pFontColor + sep + pBackColor + sep + pFontSize + sep + pFontName + sep + pFontBold + sep + pFontItalic + sep + pFontUnderline;
		chatclient.send("MSG", strMessage);
	}
	
	public void SendToMsg(String pStr, String pTo, String pFontColor, String pBackColor, String pFontSize, String pFontName, String pFontBold, String pFontItalic, String pFontUnderline)
	{
		String strMessage;
		
		strMessage = pStr + sep + pTo + sep + pFontColor + sep + pBackColor + sep + pFontSize + sep + pFontName + sep + pFontBold + sep + pFontItalic + sep + pFontUnderline;
		chatclient.send("TOMSG", strMessage);
	}
	
	public void SendExitRoom()
	{
		chatclient.send("EXITROOM", "");
	}
	
	public void SendRoomList()
	{
		chatclient.send("ROOMLIST", "");
	}
	
	public void SendChangeName(String pName, String pIcon)
	{
		chatclient.send("CHANGENAME", "" + sep + pName + sep + pIcon);
		SetName(pName);
		SetIcon(pIcon);
	}
	
	public void SendIntroduce(String pStr)
	{
		chatclient.send("INTRODUCE", pStr);
	}
	
	public void SendMusic(String pStr)
	{
		chatclient.send("MUSIC", pStr);
	}
	
	public void SendMemo(String pMsg, String pToid)
	{
		chatclient.send("MEMO", pMsg + sep + pToid);
	}
	
	public void SendGoout(String pToid)
	{
		chatclient.send("GOOUT", "" + sep + pToid);
	}
	
	public void SendChangeMaster(String pToid)
	{
		chatclient.send("CHANGEMASTER", "" + sep + pToid);
	}
	
	public void SendRoomInfo()
	{
		chatclient.send("ROOMINFO", "" + sep + GetRoomid());
	}
	
	public void SendMasterRoomInfo()
	{
		chatclient.send("MASTERROOMINFO", "" + sep + GetRoomid());
	}
	
	public void SendChangeRoomInfo(String pRoomname, String pRoomlimit, String pRoomtype, String pRoompass, String pRoomgroup)
	{
		if (GetMaster().equals("1"))
		{
			chatclient.send("CHANGEROOMINFO", "" + sep + GetRoomid() + sep + pRoomname + sep + pRoomlimit + sep + pRoomtype + sep + pRoompass + sep + pRoomgroup);
		}
	}
	
}
